-- Virtual coordinates demo.
-- Draws a sine wave.

without warning

include v_coords.e

constant PI         = 3.14159265359,    -- Everyone should know what this is.
	 RAD_TO_DEG = PI / 180          -- Converts radians to degrees.

procedure main()
    atom y
    
    set_mode(18)
    set_coords(-361, 3, 361, -3)
    
    draw_line(3, {{dx(-360), dy(0)}, {dx(360), dy(0)}})
    
    set_color(1)
    box({dx(-360), dy(2)}, {dx(360), dy(-2)})
    
    set_color(4)
    graph_pos = {dx(-360), dy(sin(-360 * RAD_TO_DEG))}
    for x = -360 to 360 do
	y = sin(x * RAD_TO_DEG)
	line_to({dx(x), dy(y)})
    end for
end procedure

main()
if getc(0) then
end if
if graphics_mode(-1) then
end if

