include graphics.e

global object
    graph_pos,                          -- Graphics cursor position.
    graph_color                         -- Currrent graphics color.

global procedure set_mode(atom mode)
    if graphics_mode(mode) then
	puts(1, "This video mode doesn't work!!!")
	abort(0)
    end if
end procedure

global procedure set_color(atom color)
    graph_color = color
end procedure
    
global procedure fade_in(atom color)
    object n
    n = {palette(color, {0, 0, 0}), palette(color, n[1])}
    
    while n[1][1] < 63 or n[1][2] < 63 or n[1][3] < 63 do
	for t = 1 to 3 do
	    if n[1][t] < 63 then
		n[1][t] = n[1][t] + 1
	    end if
	    n[2] = palette(color, n[1])
	end for
    end while
end procedure
    
global procedure fade_out(atom color)
    object n
    
    n = {{}, {}}
    n[1] = palette(color, {0, 0, 0})
    n[2] = palette(color, n[1])
    
    while n[1][1] > 0 or n[1][2] > 0 or n[1][3] > 0 do
	for t = 1 to 3 do
	    if n[1][t] > 0 then
		n[1][t] = n[1][t] - 1
	    end if
	    n[2] = palette(color, n[1])
	end for
    end while
end procedure
    
global procedure line_to(sequence pos)
    draw_line(graph_color, {graph_pos, pos})
    graph_pos = pos
end procedure

global procedure box(sequence pos_1, sequence pos_2)
    polygon(graph_color, 0, {pos_1, {pos_1[1], pos_2[2]}, pos_2,
			    {pos_2[1], pos_1[2]}})
end procedure

global procedure delay(atom n)
    sequence d
    d = {0, 1, 2}
    for t = 1 to n do
	d = d & {0, 1, 2}
    end for
end procedure

global procedure video_io()
    graph_pos = {0, 0}
    graph_color = 0
end procedure

video_io()
